/**
 * bingo用ファンクション
 */
"use strict";
(function($){
var loadedFile = {};
/**
 * head内link追加
 * @param  {[type]} style [description]
 * @param  {[type]} id    [description]
 * @param  {[type]} media [description]
 * @return {[type]}       [description]
 */
function bLoadLinkFile(path) {
    var l = document.createElement('link');
    if(typeof loadedFile[path] == "undefined") {
        var jQueryAjaxSettingsCache = jQuery.ajaxSettings.cache;
        l.rel="stylesheet";
        l.type="text/css";
        l.media="all";
        l.href = path;
        //追加
        jQuery.ajaxSettings.cache = true;
        $('head:eq(0)').append(l);
        jQuery.ajaxSettings.cache = jQueryAjaxSettingsCache;
        loadedFile[path] = path;
    }
}
window.bLoadLinkFile = bLoadLinkFile;

/**
 * head内JS追加
 * @param  {[type]} style [description]
 * @param  {[type]} id    [description]
 * @param  {[type]} media [description]
 * @return {[type]}       [description]
 */
function bLoadJsFile(path) {
    var l = document.createElement('script');
    if(typeof loadedFile[path] == "undefined") {
        var jQueryAjaxSettingsCache = jQuery.ajaxSettings.cache;
        l.type = "text/javascript";
        l.src = path;
        //追加
        jQuery.ajaxSettings.cache = true;
        $('head:eq(0)').append(l);
        jQuery.ajaxSettings.cache = jQueryAjaxSettingsCache;
        loadedFile[path] = path;
    }
}
window.bLoadJsFile = bLoadJsFile;

/**
 * head内スタイル追加
 * @param  {[type]} style [description]
 * @param  {[type]} id    [description]
 * @param  {[type]} media [description]
 * @return {[type]}       [description]
 */
function unitAppendStyle(style, id, media) {
    var l = document.getElementById(id) || document.createElement('style');
    l.id=id;
    l.type='text/css';
    if(media!=null) {
        l.media=media;
    }
    //改行コードを削除
    style = style.replace(/\r?\n/g,"");
    $(l).html(style);

    //既に同じIDがあれば削除
    $('head').find('#'+id).remove();
    //追加
    $('head:eq(0)').append(l);
}
window.unitAppendStyle = unitAppendStyle;

/**
 * ブロック要素でリンクさせる
 */
function BlockLinker(selector, cursor) {
    if(selector == null) {
        selector = "body";
    }
    if(cursor == null) {
        cursor = true;
    }
    $(selector + " [data-block-link]").each(function(){
        if(cursor) {
            $(this).css({cursor: 'pointer'});
        }

        $(this).off('.blockLinker')
        .on('mouseenter.blockLinker', function(e) {
            $(this).addClass('hover');
        })
        .on('mouseleave.blockLinker', function(e) {
            $(this).removeClass('hover');
        })
        .on('click.blockLinker', function(e) {
            var a = document.createElement('a');
            var url = $(this).data('blockLink');
            var target = $(this).data('blockLinkTarget');

            a.href = url;
            if(target == '_blank') {
                a.target = target;
            }
            $(a).text('click');
            $(a).css({visibility: 'visible', position: 'absolute'}).appendTo('body');
            setTimeout(function(){
                a.click();
                $(a).remove();
            }, 10);

            e.stopPropagation();
            e.preventDefault();
        });
    });
}
window.BlockLinker = BlockLinker;

var bYTPlayer = function() {
    this.YT = null;
    this.ids = {};
    this.trigger = {};
    this.players = {};
    this.params = {};
    this.no = 0;
    return this.init();
}

bYTPlayer.prototype = {
    youtube_api_url: "https://www.youtube.com/iframe_api",
    init: function() {
        var self = this;
        $(window).off('.ytplayeronload').on('load.ytplayeronload', function() {
            self.observeYTLoad();
        });

        return this;
    },
    getUnique: function() {
        return "bYTPlayerFrame"+this.no++;
    },
    add: function(key, id, trigger, param) {
        if(key == null) {
            console.error('element is not found.');
            return;
        }
        if(id == null) {
            console.error('videoId is not found.');
            return;
        }

        if(id.match(/https:\/\/youtu.be\/.*/)) {
            id = id.replace("https://youtu.be/", "");
        }

        if(trigger == null) {
            trigger = "scroll";
        }
        if(param == null) {
            param = {};
        }

        if(typeof key == 'object') {
            key.id = this.getUnique();
            key = key.id;
        }

        this.ids[key] = id;
        this.trigger[key] = trigger;
        this.params[key] = param;

        return key;
    },
    observeYTLoad: function() {
        var self = this;
        var id = setInterval(function() {
            if(window.YT && window.YT.Player) {
                clearInterval(id);
                self.YT = window.YT;
                self.onYouTubeIframeAPIReady();
            }
        }, 200);

        bLoadJsFile(this.youtube_api_url);
    },
    onYouTubeIframeAPIReady: function() {
        var self = this;

        for(var key in this.ids) {
            (function(_key){
                var id = self.ids[_key];
                var param = self.params[_key];
                var playerVars = {
                    origin: param.origin|| location.protocol + '//' + location.hostname,
                    controls: param.controls||0,
                    showinfo: param.showinfo||0,
                    rel: param.rel||0,
                    loop: param.loop||0,
                    modestbranding: param.modestbranding||0,
                    iv_load_policy: 3
                }

                if(param.loop == 1) {
                    playerVars.playlist = id;
                }

                var player = new YT.Player(_key, {
                    videoId: id,
                    playerVars: playerVars,
                    events: {
                        'onReady': function(e){ self.onPlayerReady.call(self, e, _key); },
                        'onStateChange': function(e){ self.onPlayerStateChange.call(self, e, _key); }
                    }
                });
                self.players[_key] = player;

                self.setPlayTrigger(_key);
            })(key);
        }
    },
    onPlayerReady: function(e, key) {
        // var key = e.target.a.id;
        var param = this.params[key];
        if(this.players[key]) {
            $('#'+key).trigger('onPlayerReady', e);
        }
    },
    onPlayerStateChange: function(e, key) {
        // var key = e.target.a.id;
        if(this.players[key]) {
            $('#'+key).trigger('onPlayerStateChange', e);
        }
    },
    loadVideo: function(key) {
        var self = this;
        if(this.ids[key]) {
            var id = this.ids[key];
            var param = this.params[key];
            var playerVars = {
                origin: param.origin||'',
                controls: param.controls||0,
                showinfo: param.showinfo||0,
                rel: param.rel||0,
                loop: param.loop||0,
                modestbranding: param.modestbranding||0,
                iv_load_policy: 3
            }

            if(param.loop == 1) {
                playerVars.playlist = id;
            }

            var player = new YT.Player(key, {
                videoId: id,
                playerVars: playerVars,
                events: {
                    'onReady': function(e){ self.onPlayerReady.call(self, e); },
                    'onStateChange': function(e){ self.onPlayerStateChange.call(self, e); }
                }
            });
            this.players[key] = player;

            this.setPlayTrigger(key);
        }
    },
    playVideo: function(key) {
        var self = this;
        var param = this.params[key];
        if(!this.YT || !this.players[key] || !this.players[key].playVideo) {
            var id = setInterval(function(){
                if(!self.YT || !self.players[key] || !self.players[key].playVideo) {
                    self.playVideo(key);

                    return;
                }
                if(param.seekTo == null) {
                    self.players[key].playVideo();
                } else {
                    self.players[key].seekTo(param.seekTo);
                }
                if(param.mute) {
                    self.players[key].mute();
                }
                clearInterval(id);
            }, 200);
            return;
        }
        if(param.seekTo == null) {
            this.players[key].playVideo();
        } else {
            this.players[key].seekTo(param.seekTo);
        }
        if(param.mute) {
            this.players[key].mute();
        }
    },
    pauseVideo: function(key) {
        if(!this.YT || !this.players[key] || !this.players[key].pauseVideo) {
            return;
        }
        this.players[key].pauseVideo();
    },
    stopVideo: function(key) {
        if(!this.YT || !this.players[key] || !this.players[key].stopVideo) {
            return;
        }
        this.players[key].stopVideo();
    },
    setPlayTrigger: function(key) {
        var self = this;
        var trigger = this.trigger[key];
        switch(trigger[0]) {
            case 'hover':
                (function(key){
                    $('#'+trigger[1]).on('mouseenter', function(e){
                        self.playVideo(key);
                    }).on('mouseleave', function(e){
                        self.pauseVideo(key);
                    });
                })(key);
                break;
            case 'click':
                (function(key){
                    $('#'+trigger[1]).on('click.ytplayerevents', function(e){
                        if(self.players[key].getPlayerState() != 1) {
                            self.playVideo(key);
                        } else {
                            self.pauseVideo(key);
                        }
                        e.stopPropagation();
                        e.preventDefault();
                    });
                })(key);
                break;
            case 'scroll':
                (function(key){
                    var f = 0;
                    $('#'+trigger[1]).on('inview', function(e, view){
                        if(view&&!f) {
                            f = 1;
                            self.playVideo(key);
                        } else if(!view && f) {
                            f = 0;
                            self.pauseVideo(key);
                        }
                    });
                })(key);
                break;
        }
    }
}

if(!window.bYTPlayer) {
    window.bYTPlayer = new bYTPlayer();
}

})(jQuery);

/**
 * ツールチップ
 * @param  {[type]} function($ [description]
 * @return {[type]}            [description]
 */
(function ($) {
var name = "bTip";
var f = function (selecter, opt) {
    if (opt == null) {
        opt = {};
    }
    this.elm = $(selecter);
    this.selecter = selecter;
    this.container = opt.container || null;
    this.axis = opt.axis || "bottom center";
    this.trigger = opt.trigger || "click";
    this.time = opt.time || 300;
    this.offset = opt.offset || [0, 0];
    this.uniqkey = opt.group || "bTipActive";
    this._callback = function(tip){};

    return this.init();
}

f.prototype = {
    init: function () {
        var self = this;
        if (this.container != null) {
            $(this.container).on(self.trigger, this.selecter, function (e) {

                if (self.uniqkey != "") {
                    $("." + self.uniqkey).remove();
                }
                var element = e.target;
                var box = $(this).data("tipBox");
                var text = $(this).data("tipTitle");
                var link = $(this).data("tipLink");
                var tip = document.createElement("div");
                var tipText = document.createElement("span");
                var tipLink = document.createElement("a");
                var flag = true;

                var setCloseEvent1 = function () {
                    $(element).off("mouseleave").on("mouseleave", function () {
                        flag = true;
                        setTimeout(function () {
                            if (flag) {
                                $(tip).remove();
                            }
                        }, self.time);
                    });
                }
                var setCloseEvent2 = function () {
                    $(tip).off("mouseleave").on("mouseleave", function () {
                        flag = true;
                        setTimeout(function () {
                            if (flag) {
                                $(tip).remove();
                            }
                        }, self.time);
                    });
                }
                $(element).on("mouseenter", function () {
                    flag = false;
                });
                setCloseEvent1();

                $(tip).on("mouseenter", function () {
                    flag = false;
                });
                setCloseEvent2();

                if (typeof box == "undefined" || box == "" || box == null) {
                    $(tipText).html(text);
                    $(tip).append(tipText);
                    if (typeof link != "undefined" && link != "" && link != null) {
                        $(tipLink).attr({
                            href: link
                        });
                        $(tipText).wrap(tipLink);
                    }
                } else {
                    $(tip).append($(box).clone());
                }
                $(tip).addClass("bTip " + self.uniqkey).appendTo("body");
                self.setPosition(e, element, $(tip));

                $(self).trigger("bTipShow", {
                    tip: tip,
                    target: element,
                    link: link,
                    text: text
                });

                e.preventDefault();
            });
        } else {
            this.elm.on(self.trigger, function (e) {
                if (self.uniqkey != "") {
                    $("." + self.uniqkey).remove();
                }
                var element = e.target;
                var box = $(this).data("tipBox");
                var text = $(this).data("tipTitle");
                var link = $(this).data("tipLink");
                var tip = document.createElement("div");
                var tipText = document.createElement("span");
                var tipLink = document.createElement("a");
                var flag = true;

                $(tip).hide();

                var setCloseEvent1 = function () {
                    $(element).off("mouseleave").on("mouseleave", function () {
                        flag = true;
                        setTimeout(function () {
                            if (flag) {
                                $(tip).remove();
                            }
                        }, self.time);
                    });
                }
                var setCloseEvent2 = function () {
                    $(tip).off("mouseleave").on("mouseleave", function () {
                        flag = true;
                        setTimeout(function () {
                            if (flag) {
                                $(tip).remove();
                            }
                        }, self.time);
                    });
                }
                $(element).on("mouseenter", function () {
                    flag = false;
                });
                setCloseEvent1();

                $(tip).on("mouseenter", function () {
                    flag = false;
                });
                setCloseEvent2();

                if (typeof box == "undefined" || box == "" || box == null) {
                    $(tipText).html(text);
                    $(tip).append(tipText);
                    if (typeof link != "undefined" && link != "" && link != null) {
                        if(link == 'callback'){
                            $(tipLink).on('click', function(){
                                self._callback(tip);
                            });
                        }else{
                            $(tipLink).attr({
                                href: link
                            });
                        }
                        $(tipText).wrap(tipLink);
                    }
                } else {
                    var cbox = $(box).clone();
                    cbox.show();
                    $(tip).append(cbox);
                }

                $(this).trigger('bTipBeforeShow', tip);
                $(tip).show();

                $(tip).addClass("bTip " + self.uniqkey).appendTo("body");
                self.setPosition(e, element, $(tip));

                e.preventDefault();
            });
        }
    },
    /*
     * 位置セット
     * @return {[type]} [description]
     */
    setPosition: function (e, target, view) {
        var self = this;
        var marginTop = 0;
        var margin = 0;
        var offset = $(target).offset();
        var w = $(target).outerWidth();
        var h = $(target).outerHeight();
        var winW = $(window).width();
        var winH = $(window).height();
        var pos = offset;
        var posClass = "tip";

        if (self.axis.match("top")) {
            pos.top -= view.outerHeight() - self.offset[0];
            posClass += "T";
        } else if (self.axis.match("center ")) {
            pos.top += (h - view.outerHeight()) / 2 + self.offset[0];
            posClass += "C";
        } else if (self.axis.match("bottom")) {
            pos.top += h + self.offset[0];
            posClass += "B";
        }

        if (self.axis.match("left")) {
            pos.left -= view.outerWidth() - self.offset[1];
            posClass += "L";
        } else if (self.axis.match("right")) {
            pos.left += w + self.offset[1];
            posClass += "R";
        } else if (self.axis.match(" center")) {
            pos.left += (w - view.outerWidth()) / 2 + self.offset[1];
            posClass += "C";
        }

        if(pos.left < 0) {
            //左見きれた時
            pos.left = 0;
            posClass += ' bTipLeft';
        } else if(winW < pos.left+view.outerWidth()) {
            //右見きれた時
            pos.left = winW-view.outerWidth();
            posClass += ' bTipRight';
        }

        view.css(pos).addClass(posClass);
    },
    callback: function(f){
        this._callback = f;
    }
}

window[name] = f;
})(jQuery);

/**
 *  vw, vh pollyfill
 */
(function($){
    $(function(){
        var setDataStyle = function(element, style_data) {
            var style = style_data;
            var hv = window.innerHeight;
            var wv = $(window).width();
            var mh = style.match(/([\d\.]+)vh/);
            var mw = style.match(/([\d\.]+)vw/);

            if(mh) {
                var num = ~~mh[1];
                var search = mh[0];
                var replace = hv * (num / 100) + "px";
                style = style.replace(search, replace);
            }

            if(mw) {
                var num = ~~mw[1];
                var search = mw[0];
                var replace = hv * (num / 100) + "px";
                style = style.replace(search, replace);
            }

            $(element).css('cssText', style);
        }
        if($('html').hasClass('ios') || $('html').hasClass('mobile') || $('html').hasClass('ipad') || $('html').hasClass('tablet')) {
            $(document).find('[data-style]').each(function(){
                var self = this;
                var style = $(this).data('style');
                var mh = style.match(/([\d\.]+)vh/);
                var mw = style.match(/([\d\.]+)vw/);

                setDataStyle(this, style);

                if(mh || mw) {
                    window.addEventListener('resize', function(){
                        setDataStyle(self, style);
                    });
                    // window.addEventListener('orientationchange', function(){
                    //     setDataStyle(self, style);
                    // });
                }
            });
        }
    });
})(jQuery);

/**
 * 処理中レイヤー表示
 */
(function($){
    var name = "Layer";
    var f = function (opt) {
        if (opt == null) {
            opt = {};
        }
        // this.elm = $(selecter);
        // this.selecter = selecter;
        this.container = opt.container || 'body';
        this.uniqkey = opt.uniqkey || 'progress-layer';
        this.color = opt.color || 'rgba(255,255,255,.6)';
        this.zIndex = opt.zIndex || 2;
        this.duration = opt.duration || 200;
        this.layer = null;
        this.style = opt.style || {
            backgroundColor: this.color,
            width: "100%",
            height: "100%",
            position: "fixed",
            top: 0,
            left: 0,
            zIndex: this.zIndex,
            display: 'flex',
            'justify-content': 'center',
            'align-items': 'center'
        }
        this.loader = opt.loader || "<div class=\"loader loader-1\">\
<div class=\"loader-outter\"></div>\
<div class=\"loader-inner\"></div>\
</div>";

        return this.init();
    }

    f.prototype = {
        init: function() {
            if($('head').find('#layer-style').length <= 0) {
                $('head:first').append('<style id="layer-style" type="text/css">.progress-layer{ display: none; } .progress-layer-show{ display: block; }</style>');
            }

            return this;
        },
        show: function() {
            var defer = $.Deferred();
            var layer = document.getElementById(this.uniqkey);
            var style = null;
            if(layer == null) {
                layer = document.createElement('div');
                layer.id = this.uniqkey;
                $(layer).addClass('progress-layer').css(this.style).appendTo(this.container);

                if(this.loader != null && this.loader != "") {
                    $(layer).append($.parseHTML(this.loader));
                }
            }
            this.layer = layer;

            $(this.layer).addClass('progress-layer-show').animate({opacity: 1}, this.duration, function(){
                defer.resolve();
            });

            return defer.promise();
        },
        hide: function(destroy) {
            var self = this;
            var defer = $.Deferred();
            var layer = document.getElementById(this.uniqkey);
            if(destroy == null) {
                destroy = false;
            }
            if(layer!=null) {
                $(layer).animate({opacity: 0}, this.duration, function(){
                    $(layer).removeClass('progress-layer-show');
                    if(destroy) {
                        self.destroy();
                    }
                    defer.resolve();
                });
            } else {
                defer.reject();
            }

            return defer.promise();
        },
        destroy: function() {
            var layer = document.getElementById(this.uniqkey);
            $(layer).remove();
        }
    }

    if(!window[name]) {
        window[name] = f;
    }
})(jQuery);

/**
 * ポップアップ
 * @type {String}
 */
(function($) {
  var name = "bSimplePopup";
  var f = function(simpopId) {
    this.id = simpopId;
    this.wd = null;
    this.tmp = [];

    return this.init();
  }

  f.prototype = {
    init: function() {
      return this;
    },
    create: function(opt) {
      var self = this;
      var html = "<div id=\"simpop\" style=\"opacity:0;\">\
            <div class=\"simpop-inner\">\
              <div class='simpop-main'></div>\
            </div>\
            <a href=\"#\" class=\"close\">\
              <span>×</span>\
            </a>\
        </div>";
      $("body").append($.parseHTML(html));

      if(opt==null) {
          opt = {}
      }

      this.wd = $('#simpop');
      this.wd.find('.close').on('click', function(e) {
        self.destroy();
        $(document).trigger('onSimplePopupClose');
        e.stopPropagation();
        e.preventDefault();
      });
      var colorClass = "light";
      if(opt.backgroundColor) {
        this.wd.css({backgroundColor: opt.backgroundColor});
        var rgb = null;
        if(opt.backgroundColor.match(/^#[0-9a-f]{6}/i)) {
            //16進数はrgbに変換
            rgb = [null];
            rgb.push(~~("0x"+opt.backgroundColor.substr(1,2)));
            rgb.push(~~("0x"+opt.backgroundColor.substr(3,2)));
            rgb.push(~~("0x"+opt.backgroundColor.substr(5,2)));
        } else {
            var bgcolor = j$(this).css("background-color");
            rgb = bgcolor.match(/^rgb\((\d+),.?(\d+),.?(\d+)\)/);
        }
      　if(rgb) {
          var brightless = (~~rgb[1]+~~rgb[2]+~~rgb[3]) / 3 / 255;
          if(0.7 <= brightless) {
            colorClass = "light";
          } else {
            colorClass = "dark";
          }
        }
      }

      this.wd.addClass(colorClass);

      if(opt.width) {
          this.wd.find('.simpop-inner').width(opt.width);
      }
      if(opt.height) {
          this.wd.find('.simpop-inner').height(opt.height);
      }
      self.tmp[0] = $('html').css('overflow');
      self.tmp[1] = $('body').css('overflow');
      self.tmp[2] = $(window).scrollTop();
      $('html,body').css({
        'overflow': 'hidden'
      });

      this.wd.css({opacity:1});

      return this;
    },
    destroy: function() {
      this.wd.remove();
      this.wd = null;

      $('html').css('overflow', '');
      $('body').css('overflow', '');
      $(window).scrollTop(this.tmp[2]);

      return this;
    },
    setId: function(id) {
      this.wd.find('.simpop-main').attr('id', id);

      return this;
    }
  };

  if (!window[name]) {
    window[name] = f;
  }
})(jQuery);


(function($){
    var bMainScroll = function(p, t, ease, parent, offset) {
        var d = $.Deferred();
        var easing = ease;
        if(parent == null) {
            parent = window;
        }
        if(t == null) {
            t = 1;
        }
        if(ease == null) {
            ease = "easeOutQuart";
        }
        if(offset == null) {
            offset = 0;
        }

        if(p == null) {
            console.error('p is undefined');
            d.reject();
            return d.promise();
        }

        if(typeof p == "string") {
            p = Math.abs(j$(parent).scrollTop() + $(p).position().top);
        }
        $.Animation({scroll:j$(parent).scrollTop()}, {scroll:p-offset}, {duration: t, easing: easing}).progress(function() {
            $(parent).scrollTop(this.scroll);
        }).done(function() {
            d.resolve();
        });

        return d.promise();
    }

    window.bMainScroll = bMainScroll;
})(jQuery);


(function($){
    var _f = function(selector, option) {
        if(selector == null) {
            selector = "[data-dialog]";
        }
        if(option == null) {
            option = {};
        }
        this.element = null;
        this.selector = selector;
        this.option = option;
        this.html = {
            base: '<div class="dialog-layer">\
            <div class="dialog">\
                <div class="inner">\
                    <div class="dialog-header"><strong class="dialog-title"></strong></div>\
                    <div class="dialog-content"></div>\
                    <div class="dialog-footer"></div>\
                </div>\
            </div>\
        </div>',
            buttons: {
                confirm: '<a href="#ok" class="ok">OK</a><a href="#cencel" class="cancel">CNACEL</a>',
                dialog: '<a href="#ok" class="ok">OK</a>'
            }
        }

        if(option.html) {
            if(option.html.base) {
                this.html.base = option.html.base;
            }
            if(option.html.buttons) {
                if(option.html.buttons.confirm) {
                    this.html.buttons.confirm = option.html.buttons.confirm;
                }
                if(option.html.buttons.dialog) {
                    this.html.buttons.dialog = option.html.buttons.dialog;
                }
                if(option.html.buttons.custom) {
                    this.html.buttons.confirm = option.html.buttons.custom;
                    this.html.buttons.dialog = option.html.buttons.custom;
                }
            }
        }

        return this.init();
    }

    _f.prototype = {
        init: function() {
            return this;
        },
        'confirm': function(message, title) {
            var self = this;
            var defer = $.Deferred();
            var d = this.create(message, title);
            d.querySelector(".dialog-footer").innerHTML = this.html.buttons.confirm;
            document.body.appendChild(d);

            $(d).find('.cancel').on('click', function(e) {
                e.stopPropagation();
                e.preventDefault();
                defer.resolve(e);
            });
            $(d).find('.ok').on('click', function(e) {
                e.stopPropagation();
                e.preventDefault();
                defer.resolve(e);
            });
            $(d).find('.close').on('click', function(e) {
                e.stopPropagation();
                e.preventDefault();
                $(self).destroy();
            });
            this.element = d;

            return defer.promise();
        },
        'dialog': function(message, title) {
            var self = this;
            var defer = $.Deferred();
            var d = this.create(message, title);
            d.querySelector(".dialog-footer").innerHTML = this.html.buttons.dialog;
            document.body.appendChild(d);

            $(d).find('.ok').on('click', function(e) {
                e.stopPropagation();
                e.preventDefault();
                defer.resolve(e);
            });
            $(d).find('.close').on('click', function(e) {
                e.stopPropagation();
                e.preventDefault();
                $(self).destroy();
            });
            this.element = d;

            return defer.promise();
        },
        'alert': function(message, title) {
            return this.dialog.call(this, message, title);
        },
        'custom': function(message, title) {
            var self = this;
            var defer = $.Deferred();
            var d = this.create(message, title);
            d.querySelector(".dialog-footer").innerHTML = this.html.buttons.confirm;
            document.body.appendChild(d);

            $(d).find('[data-handler]').on('click', function(e) {
                e.stopPropagation();
                e.preventDefault();

                var type = $(this).data('event');
                defer.resolve(e, type);
            });
            $(d).find('.close').on('click', function(e) {
                e.stopPropagation();
                e.preventDefault();

                $(self).destroy();
            });
            this.element = d;

            return defer.promise();
        },
        create: function(message, title) {
            var div = document.createElement('div');
            var d = null;
            div.innerHTML = this.html.base.trim();
            d = div.firstChild;

            if(title != null) {
                d.querySelector(".dialog-title").innerText = title;
            } else {
                d.querySelector(".inner").removeChild(d.querySelector(".dialog-header"));
            }
            if(message != null) {
                d.querySelector(".dialog-content").innerText = message;
            }

            return d;
        },
        'destroy': function() {
            document.body.removeChild(this.element);
        }
    }
    if(!window.DialogBase) {
        window.DialogBase = _f;
    }
})(jQuery);
